<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">
    <script src="https://libs.lixend.com/jquery.min.js"></script>
    <link href="https://fonts.googleapis.com/css?family=Source+Sans+Pro" rel="stylesheet">
    <link href="https://fonts.googleapis.com/css?family=IBM+Plex+Sans" rel="stylesheet">
    <style>
      body, html {
        font-family: 'IBM Plex Sans', sans-serif;
        color: #222222;
        background-color: #efefef;
      }
      a {
        color: inherit;
        text-decoration: none;
      }
      #top {
        font-family: 'Source Sans Pro', sans-serif;
        display: flex;
        flex-direction: row;
        align-items: flex-end;
        flex-wrap: wrap;
        padding: 15px;
      }
      h1#title {
        font-size: 2.2em;
        display: flex;
        margin: 0;
        margin-right: 20px;
      }
      #subtitle{
        padding: 5px;
      }
      #counter {
        color: #3D92EC;
        display: inline-block;
        margin-right: 2px;
        font-weight: bold;
      }
      #content {
        display: flex;
        flex-direction: column;
        padding: 10px;
      }
      #searchbar {
        text-align: center;
        border-bottom: 2px dotted #9f9f9f;
        padding-bottom: 30px;
        margin-bottom: 30px;
      }
      #searchbar > * {
        margin: 10px;
      }
      input, select {
        font-size: 1.5em;
        padding: 10px;
        border-radius: 5px;
        border: 2px solid #efefef;
        outline: none;
        width: 300px;
        text-align: center;
        text-align-last: center;
        text-transform: uppercase;
        font-weight: bold;
        background-color: #dfdfdf;
        color: #555;
        box-shadow: 1px 1px 15px 0px rgba(0,0,0,0.25);
        margin-right: 20px;
      }
      input:focus::placeholder {
        color: transparent;
      }
      .error {
        font-size: 22px;
        text-align: center;
        color: #ec3d65;
      }
      #words {
        color: #3D92EC;
        font-size: 22px;
        font-weight: bold;
        font-family: 'IBM Plex Sans', sans-serif;
      }


    </style>

    <title>Dico</title>
  </head>
  <body>
    <div id="top">
      <h1 id="title">Dictionnary search</h1>
      <div id="subtitle">
        <span id="counter"></span> words in total from <span id="langFile"></span>
      </div>
    </div>
    <div id="content">
      <div id="searchbar">
        <select id="dico">
          <option value="fr.txt" selected>French</option>
          <option value="en.txt">English</option>
        </select>
        <input id="search" placeholder="Search..." type="text" value="">
      </div>
      <div id="error" class="error"></div>
      <div id="words"></div>
    </div>
  </body>

</html>
<script>
var DATA = [];
var SEARCH = "";
var langFile = "fr.txt";

// Changing the current langage files
$("#dico").on("change", (e) => {
  let value = e.currentTarget.value;
  if(langFile != value) {
    langFile = value;
    getDico(langFile);
  }
});

// Gets the full dictionnary and display filtered result
var getDico = function(langFile){
  $.get(langFile).done( (data) => {
    DATA = data.split("\n");
    SEARCH = $("#search").val();
    $("#langFile").text(langFile);
    filterDico(DATA, SEARCH);
  });
}

// Filters words on keyup using debouncer
var keyupTimeout = null;
$("#search").on("keyup", function(e) {
  SEARCH = $(this).val();
  if(e.key == "Escape") {
    $("#search").val("");
    SEARCH = "";
  }
  if(e.key === "Enter"){
    $("#search").blur();
  }
  if(keyupTimeout){ clearTimeout(keyupTimeout); }
  keyupTimeout = setTimeout( function() {
    filterDico(DATA, SEARCH);
  }, 400);
});

//  Filters data with the search criteria
var filterTimeout = null;
filterDico = function(DATA, search) {
  if(!DATA){ return; }
  $("#error").text("");
  search = search.toLowerCase();
  if(search.length < 2) {
    $("#error").text("Please type at least 2 letters");
    $("#counter").text(DATA.length);
    $("#words").text("");
    return;
  }
  $("#words").text("LOADING...");

  if(filterTimeout){ clearTimeout(filterTimeout); }
  filterTimeout = setTimeout( () => {
    var newData = DATA;
    if(search.trim() != ""){
      newData = newData.filter( function(w){
        var a =  w.toLowerCase();
        var an = a.normalize('NFD').replace(/[\u0300-\u036f]/g, "");
        an = an.replace(new RegExp("œ", 'g'),"oe");
        an = an.replace(new RegExp("æ", 'g'),"ae");
        return a.indexOf(search) > -1 || an.indexOf(search) > -1;
      });
    }

    if(newData.length < 1000){
      let link;
      if(langFile == "fr.txt") { link = "https://dictionnaire.reverso.net/francais-definition/"; }
      else if(langFile == "en.txt"){ link = "https://www.dictionary.com/browse/"; }

      if(link !== undefined){
        newData = newData.map( function(w){ return "<a target='_blank' href='"+link+w+"'>"+w+"</a>";});
      }
    }
    if(newData.length == 0) {
      $("#words").html("<span class='error'>Nothing found…</span>");
    } else {
      $("#words").html( newData.join(", "));
    }
    $("#counter").text(newData.length);
  }, 100);
}

// Main
getDico(langFile);
setTimeout(() => {
  $("#search").focus();
}, 500);
</script>
